"""
    misc. utility functions
"""
import os

def ext(f):
    (p, ex) = os.path.splitext(f)
    return ex.lower()

def createDirIfNotExisting(f):
    if not os.path.isdir(f):
        os.mkdir(f)

def addSlashIfNeeded(path):
    if path[-1] == '/':
        return path
    else:
        return path  + '/'

def remove_ending_slash_if_not_root(path):
    if path[-1] == '/' and path != "/":
        return path[0: len(path)-1]
    else:
        return path
    

def forall(list, pred):
    for l in list:
        if not pred(l):
            return False
    return True


def find(list, pred):
    for l in list:
        if pred(l):
            return l
    return None

def exists(list, pred):
    return not find(list, pred) is None

def first(x):
    (a, b) = x
    return a
